module Codebreaker
  class Player
    attr_accessor(
      :rating,
      :name,
      :difficulty,
      :attempts_total,
      :attempts_used,
      :hints_total,
      :hints_used,
      :date
    )

    def initialize(name, difficulty)
      @name = name
      @difficulty = difficulty
      @attempts_total = Game::DIFFICULTIES[difficulty][:attempts]
      @attempts_used = nil
      @hints_total = Game::DIFFICULTIES[difficulty][:hints]
      @hints_used = nil
      @rating = nil
      @date = nil
    end

    def <=>(other)
      [
        -@attempts_total,
        @attempts_used,
        @hints_used
      ] <=> [
        -other.attempts_total,
        other.attempts_used,
        other.hints_used
      ]
    end

    def save_score(attempts:, hints:)
      @attempts_used = @attempts_total - attempts
      @hints_used = hints
    end
  end
end
