# :nocov:
module Codebreaker
  class Stats
    STORE = 'db/stats.yml'.freeze

    class << self
      def write(player)
        data = load
        data.push(player)

        sorted = data.sort

        data.map!.with_index do |record, index|
          record.rating = index + 1
          record
        end

        File.write(STORE, sorted.to_yaml)
      end

      def load
        File.exist?(STORE) ? YAML.load_file(STORE) : []
      end
    end
  end
end
# :nocov:
