module Codebreaker
  module Validation
    # cause guard clause will be > 80 chars
    # rubocop:disable Style/GuardClause
    def self.name_valid?(name)
      unless string?(name) && name_length_valid?(name)
        raise Codebreaker::Errors::NameError
      end
    end

    def self.answer_valid?(guess)
      unless string?(guess) && guess.match?(/^[123456]{4}$/)
        raise Codebreaker::Errors::AnswerError
      end
    end
    # rubocop:enable Style/GuardClause

    def self.name_length_valid?(name)
      name.length > 2 && name.length < 21
    end

    def self.string?(item)
      item.instance_of?(String)
    end
  end
end
